// Demo.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "Service.h"
#include "gsl\gsl.h"
#include <iostream>


#define GSL_THROW_ON_CONTRACT_VIOLATION 1

int AskServiceToDoSomething(Service* p)
{
    if (p)
    {
        return p->DoSomething();
    }
    return -1; //or some other signal value, or an appropriate default like 0
}

Service* GetPointer(Service* p)
{
    return p;
}

int main()
{
    int i;
    Service s(1);
    gsl::not_null<Service*> ps = &s;
    i = ps->DoSomething();
    i = AskServiceToDoSomething(ps);
    ps = GetPointer(nullptr);
    i = ps->DoSomething();
    std::cout << i << std::endl;
    i = AskServiceToDoSomething(ps);
    return 0;
}

